Index: pjproject/main/pjlib/include/pj++/timer.hpp
===================================================================
--- pjproject/main/pjlib/include/pj++/timer.hpp	(revision 29)
+++ pjproject/main/pjlib/include/pj++/timer.hpp	(revision 36)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJPP_TIMER_H__
@@ -7,68 +6,107 @@
 #include <pj/timer.h>
 #include <pj++/types.hpp>
+#include <pj/assert.h>
+#include <pj++/lock.hpp>
 
-class PJ_Timer_Heap;
+class Pj_Timer_Heap;
 
-class PJ_Timer_Entry : private pj_timer_entry
+//////////////////////////////////////////////////////////////////////////////
+// Timer entry.
+//
+// How to use:
+//  Derive class from Pj_Timer_Entry and override on_timeout().
+//  Scheduler timer in Pj_Timer_Heap.
+//
+class Pj_Timer_Entry : public Pj_Object
 {
-    friend class PJ_Timer_Heap;
+    friend class Pj_Timer_Heap;
 
 public:
-    static void timer_heap_callback(pj_timer_heap_t *, pj_timer_entry *);
-
-    PJ_Timer_Entry() { cb = &timer_heap_callback; }
-    PJ_Timer_Entry(int arg_id, void *arg_user_data)
-    {
-	cb = &timer_heap_callback; 
-	init(arg_id, arg_user_data);
+    //
+    // Default constructor.
+    //
+    Pj_Timer_Entry() 
+    { 
+        entry_.user_data = this;
+        entry_.cb = &timer_heap_callback; 
     }
 
-    virtual void on_timeout() = 0;
-
-    void init(int arg_id, void *arg_user_data)
+    //
+    // Destructor, do nothing.
+    //
+    ~Pj_Timer_Entry()
     {
-	id = arg_id;
-	user_data = arg_user_data;
     }
 
-    int get_id() const
+    //
+    // Override this to get the timeout notification.
+    //
+    virtual void on_timeout(int id) = 0;
+
+private:
+    pj_timer_entry entry_;
+
+    static void timer_heap_callback(pj_timer_heap_t *th, pj_timer_entry *e)
     {
-	return id;
+        Pj_Timer_Entry *entry = (Pj_Timer_Entry*) e->user_data;
+        entry->on_timeout(e->id);
     }
 
-    void set_id(int arg_id)
+};
+
+//////////////////////////////////////////////////////////////////////////////
+// Timer heap.
+//
+class Pj_Timer_Heap : public Pj_Object
+{
+public:
+    //
+    // Default constructor.
+    //
+    Pj_Timer_Heap() 
+        : ht_(NULL) 
     {
-	id = arg_id;
     }
 
-    void set_user_data(void *arg_user_data)
+    //
+    // Construct timer heap.
+    //
+    Pj_Timer_Heap(Pj_Pool *pool, pj_size_t initial_count)
+        : ht_(NULL)
     {
-	user_data = arg_user_data;
+        create(pool, initial_count);
     }
 
-    void *get_user_data() const
+    //
+    // Destructor.
+    //
+    ~Pj_Timer_Heap()
     {
-	return user_data;
+        destroy();
     }
 
-    const PJ_Time_Val &get_timeout() const
+    //
+    // Create
+    // 
+    pj_status_t create(Pj_Pool *pool, pj_size_t initial_count)
     {
-	pj_assert(sizeof(PJ_Time_Val) == sizeof(pj_time_val));
-	return (PJ_Time_Val&)_timer_value;
-    }
-};
-
-class PJ_Timer_Heap
-{
-public:
-    PJ_Timer_Heap() {}
-
-    bool create(PJ_Pool *pool, pj_size_t initial_count, 
-		unsigned flag = PJ_TIMER_HEAP_SYNCHRONIZE)
-    {
-	ht_ = pj_timer_heap_create(pool->pool_(), initial_count, flag);
-	return ht_ != NULL;
+        destroy();
+	return pj_timer_heap_create(pool->pool_(), initial_count, &ht_);
     }
 
+    //
+    // Destroy
+    //
+    void destroy()
+    {
+        if (ht_) {
+            pj_timer_heap_destroy(ht_);
+            ht_ = NULL;
+        }
+    }
+
+    //
+    // Get pjlib compatible timer heap object.
+    //
     pj_timer_heap_t *get_timer_heap()
     {
@@ -76,14 +114,41 @@
     }
 
-    bool schedule( PJ_Timer_Entry *ent, const PJ_Time_Val &delay)
+    //
+    // Set the lock object.
+    //
+    void set_lock( Pj_Lock *lock, bool auto_delete )
     {
-	return pj_timer_heap_schedule(ht_, ent, &delay) == 0;
+        pj_timer_heap_set_lock( ht_, lock->pj_lock_t_(), auto_delete);
     }
 
-    bool cancel(PJ_Timer_Entry *ent)
+    //
+    // Set maximum number of timed out entries to be processed per poll.
+    //
+    unsigned set_max_timed_out_per_poll(unsigned count)
     {
-	return pj_timer_heap_cancel(ht_, ent) == 1;
+        return pj_timer_heap_set_max_timed_out_per_poll(ht_, count);
     }
 
+    //
+    // Schedule a timer.
+    //
+    bool schedule( Pj_Timer_Entry *ent, const Pj_Time_Val &delay,
+                   int id)
+    {
+        ent->entry_.id = id;
+	return pj_timer_heap_schedule(ht_, &ent->entry_, &delay) == 0;
+    }
+
+    //
+    // Cancel a timer.
+    //
+    bool cancel(Pj_Timer_Entry *ent)
+    {
+	return pj_timer_heap_cancel(ht_, &ent->entry_) == 1;
+    }
+
+    //
+    // Get current number of timers
+    //
     pj_size_t count()
     {
@@ -91,10 +156,18 @@
     }
 
-    void earliest_time(PJ_Time_Val *t)
+    //
+    // Get the earliest time.
+    // Return false if no timer is found.
+    //
+    bool earliest_time(Pj_Time_Val *t)
     {
-	pj_timer_heap_earliest_time(ht_, t);
+	return pj_timer_heap_earliest_time(ht_, t) == PJ_SUCCESS;
     }
 
-    int poll(PJ_Time_Val *next_delay = NULL)
+    //
+    // Poll the timer.
+    // Return number of timed out entries has been called.
+    //
+    unsigned poll(Pj_Time_Val *next_delay = NULL)
     {
 	return pj_timer_heap_poll(ht_, next_delay);
